function [counts,stddevs] = std_devs(dataset, labels_provided, cents, fn_p1, fn_p2)


[n_inst, n_attr] = size(dataset);
if(labels_provided)
	n_attr = n_attr - 1;
end

for(i = 1:n_attr)
	if(mod(i,100)==0)
		i
	end
	a = dataset(:,i);
	filename = [fn_p1, num2str(i-1), fn_p2];
	cl = dlmread(filename);
	cl = cl(:,2);
	
	counts(i,1) = cents(i,1); % max(cl)+1
	for(j = 0:cents(i,1)-1) % max(cl)
		counts(i,j+2) = sum(cl==j);
	end
	
	sums = zeros(1,cents(i,1)); % max(cl)+1
% 	sums(i,1:max(cl)+1) = 0;
% 	for(j = 1:size(dataset,1))
% 		sums(i,cl(j)+1) = sums(i,cl(j)+1) + a(j);
% 	end
	
% 	cents(i,1) = max(cl)+1;
% 	for(j = 0:max(cl))
% 		cents(i,j+2) = mean(a(cl==j));
% 	end
	
	stddevs(i,1) = cents(i,1); % max(cl)+1;
% 	for(j = 0:max(cl))
% 		stddevs(i,j+2) = std(a(cl==j));
% 	end

	for(j = 1:n_inst)
		sums(cl(j)+1) = sums(cl(j)+1) + ((a(j)-cents(i,cl(j)+2)) ^ 2);
	end
	
	for(j = 0:cents(i,1)-1) % max(cl)
		stddevs(i,j+2) = sqrt(sums(j+1) / counts(i,j+2));
	end
% 	code for calculating std devs should be inserted here
end

% Another better and easier method to calculate stddevs
% for(i = 1:34)
% 	a(i,1) = stddevs(i,1);
% 	for(j = 1:stddevs(i,1))
% 		a(i,j+1) = std(dataset(labels2(:,i)==j-1, i));
% 	end
% end


end % function